﻿/***************** 
 * Illusion Test *
 *****************/

// init psychoJS:
const psychoJS = new PsychoJS({
  debug: true
});

// open window:
psychoJS.openWindow({
  fullscr: true,
  color: new util.Color([0, 0, 0]),
  units: 'height',
  waitBlanking: true
});

// store info about the experiment session:
let expName = 'Illusion';  // from the Builder filename that created this script
let expInfo = {'participant': '', 'session': '001'};

// schedule the experiment:
psychoJS.schedule(psychoJS.gui.DlgFromDict({
  dictionary: expInfo,
  title: expName
}));

const flowScheduler = new Scheduler(psychoJS);
const dialogCancelScheduler = new Scheduler(psychoJS);
psychoJS.scheduleCondition(function() { return (psychoJS.gui.dialogComponent.button === 'OK'); }, flowScheduler, dialogCancelScheduler);

// flowScheduler gets run if the participants presses OK
flowScheduler.add(updateInfo); // add timeStamp
flowScheduler.add(experimentInit);
flowScheduler.add(A_StartRoutineBegin());
flowScheduler.add(A_StartRoutineEachFrame());
flowScheduler.add(A_StartRoutineEnd());
flowScheduler.add(B_Consent1RoutineBegin());
flowScheduler.add(B_Consent1RoutineEachFrame());
flowScheduler.add(B_Consent1RoutineEnd());
flowScheduler.add(C_Consent2RoutineBegin());
flowScheduler.add(C_Consent2RoutineEachFrame());
flowScheduler.add(C_Consent2RoutineEnd());
flowScheduler.add(D_Consent3RoutineBegin());
flowScheduler.add(D_Consent3RoutineEachFrame());
flowScheduler.add(D_Consent3RoutineEnd());
flowScheduler.add(E_VideoRoutineBegin());
flowScheduler.add(E_VideoRoutineEachFrame());
flowScheduler.add(E_VideoRoutineEnd());
const trialsLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(trialsLoopBegin, trialsLoopScheduler);
flowScheduler.add(trialsLoopScheduler);
flowScheduler.add(trialsLoopEnd);
flowScheduler.add(G_EndRoutineBegin());
flowScheduler.add(G_EndRoutineEachFrame());
flowScheduler.add(G_EndRoutineEnd());
flowScheduler.add(quitPsychoJS, '', true);

// quit if user presses Cancel in dialog box:
dialogCancelScheduler.add(quitPsychoJS, '', false);

psychoJS.start({
  expName: expName,
  expInfo: expInfo,
  });


var frameDur;
function updateInfo() {
  expInfo['date'] = util.MonotonicClock.getDateStr();  // add a simple timestamp
  expInfo['expName'] = expName;
  expInfo['psychopyVersion'] = '2020.1.2';
  expInfo['OS'] = window.navigator.platform;

  // store frame rate of monitor if we can measure it successfully
  expInfo['frameRate'] = psychoJS.window.getActualFrameRate();
  if (typeof expInfo['frameRate'] !== 'undefined')
    frameDur = 1.0 / Math.round(expInfo['frameRate']);
  else
    frameDur = 1.0 / 60.0; // couldn't get a reliable measure so guess

  // add info from the URL:
  util.addInfoFromUrl(expInfo);
  
  return Scheduler.Event.NEXT;
}


var A_StartClock;
var instText;
var key_resp;
var VideoPath;
var B_Consent1Clock;
var ConsentForm1;
var Button1;
var Mouse1;
var C_Consent2Clock;
var ConsentForm2;
var Button2;
var Mouse2;
var D_Consent3Clock;
var ConsentForm3;
var Button_Agree;
var Button_Disagree;
var Mouse3;
var E_VideoClock;
var movieClock;
var movie;
var F_ResponseClock;
var TextFrame;
var instr;
var text;
var G_EndClock;
var text_2;
var globalClock;
var routineTimer;
function experimentInit() {
  // Initialize components for Routine "A_Start"
  A_StartClock = new util.Clock();
  instText = new visual.TextStim({
    win: psychoJS.window,
    name: 'instText',
    text: 'In this demo, we show how you can use text components to write a users keyboard input on screen.\n\nYou will be presented with a target word. Then, in the next routine, you will be asked to type that word.\nWhen you have finished typing the word, press "return" to end the trial.\n\n\nPress spacebar to continue...',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  key_resp = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  
  expInfo['OS'] = window.navigator.platform;
  
  var sUsrAg;
  var nIdx;
  function getBrowserId () {
      var browsers = ["MSIE", "Firefox", "Safari", "Chrome", "Opera"];
      sUsrAg = window.navigator.userAgent,
      nIdx = browsers.length - 1;
      for (nIdx; nIdx > -1 && sUsrAg.indexOf(browsers [nIdx]) === -1; nIdx--);
  
    return browsers[nIdx];
  }
  
  expInfo['OS'] = window.navigator.platform;
  expInfo['browser'] = getBrowserId();
  expInfo['xResolution'] = screen.width;
  expInfo['yResolution'] = screen.height;
  VideoPath = "Videos/FrameTEST2250.mp4";
  
  
  $.getJSON('https://api.ipify.org?format=json', function(data){
      console.log(data.ip);
  });
  
  expInfo['IP'] = data.ip
  // Initialize components for Routine "B_Consent1"
  B_Consent1Clock = new util.Clock();
  ConsentForm1 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'ConsentForm1', units : 'height', 
    image : 'Images/consent1.jpg', mask : undefined,
    ori : 0, pos : [0, 0], size : [1.4, 1.0],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : 0.0 
  });
  Button1 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Button1', units : 'height', 
    image : 'Images/button.png', mask : undefined,
    ori : 0, pos : [0.65, (- 0.45)], size : [0.1, 0.045],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -1.0 
  });
  Mouse1 = new core.Mouse({
    win: psychoJS.window,
  });
  Mouse1.mouseClock = new util.Clock();
  // Initialize components for Routine "C_Consent2"
  C_Consent2Clock = new util.Clock();
  ConsentForm2 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'ConsentForm2', units : 'height', 
    image : 'Images/consent2.jpg', mask : undefined,
    ori : 0, pos : [0, 0], size : [1.4, 0.7],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : 0.0 
  });
  Button2 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Button2', units : 'height', 
    image : 'Images/button.png', mask : undefined,
    ori : 0, pos : [0.65, (- 0.45)], size : [0.1, 0.045],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -1.0 
  });
  Mouse2 = new core.Mouse({
    win: psychoJS.window,
  });
  Mouse2.mouseClock = new util.Clock();
  // Initialize components for Routine "D_Consent3"
  D_Consent3Clock = new util.Clock();
  ConsentForm3 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'ConsentForm3', units : 'height', 
    image : 'Images/consent3.jpg', mask : undefined,
    ori : 0, pos : [0, 0], size : [1.4, 0.6],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : 0.0 
  });
  Button_Agree = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Button_Agree', units : 'height', 
    image : 'Images/agree.png', mask : undefined,
    ori : 0, pos : [(- 0.7), (- 0.45)], size : [0.15, 0.045],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -1.0 
  });
  Button_Disagree = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Button_Disagree', units : 'height', 
    image : 'Images/disagree.png', mask : undefined,
    ori : 0, pos : [0.7, (- 0.45)], size : [0.15, 0.045],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -2.0 
  });
  Mouse3 = new core.Mouse({
    win: psychoJS.window,
  });
  Mouse3.mouseClock = new util.Clock();
  // Initialize components for Routine "E_Video"
  E_VideoClock = new util.Clock();
  movieClock = new util.Clock();
  movie = new visual.MovieStim({
    win: psychoJS.window,
    name: 'movie',
    units: 'height',
    movie: VideoPath,
    pos: [0, 0],
    size: [1.6, 1],
    ori: 0,
    opacity: 1,
    loop: false,
    noAudio: true,
    });
  // Initialize components for Routine "F_Response"
  F_ResponseClock = new util.Clock();
  TextFrame = new visual.Rect ({
    win: psychoJS.window, name: 'TextFrame', units : 'height', 
    width: [0.5, 0.15][0], height: [0.5, 0.15][1],
    ori: 0, pos: [0, 0],
    lineWidth: 15, lineColor: new util.Color([(- 1), (- 1), (- 1)]),
    fillColor: new util.Color([0, 0, 0]),
    opacity: 1, depth: 0, interpolate: true,
  });
  
  instr = new visual.TextStim({
    win: psychoJS.window,
    name: 'instr',
    text: 'Type the answer in the frame below, \nand press return',
    font: 'Arial',
    units: 'norm', 
    pos: [0, 0.5], height: 0.1,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -1.0 
  });
  
  text = new visual.TextStim({
    win: psychoJS.window,
    name: 'text',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.1,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -2.0 
  });
  
  // Initialize components for Routine "G_End"
  G_EndClock = new util.Clock();
  text_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_2',
    text: 'Thank you for participanting in the experiment!',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  // Create some handy timers
  globalClock = new util.Clock();  // to track the time since experiment started
  routineTimer = new util.CountdownTimer();  // to track time remaining of each (non-slip) routine
  
  return Scheduler.Event.NEXT;
}


var t;
var frameN;
var _key_resp_allKeys;
var A_StartComponents;
function A_StartRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'A_Start'-------
    t = 0;
    A_StartClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    key_resp.keys = undefined;
    key_resp.rt = undefined;
    _key_resp_allKeys = [];
    // keep track of which components have finished
    A_StartComponents = [];
    A_StartComponents.push(instText);
    A_StartComponents.push(key_resp);
    
    A_StartComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


var continueRoutine;
function A_StartRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'A_Start'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = A_StartClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *instText* updates
    if (t >= 0.0 && instText.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      instText.tStart = t;  // (not accounting for frame time here)
      instText.frameNStart = frameN;  // exact frame index
      
      instText.setAutoDraw(true);
    }

    
    // *key_resp* updates
    if (t >= 0.0 && key_resp.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp.tStart = t;  // (not accounting for frame time here)
      key_resp.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp.clearEvents(); });
    }

    if (key_resp.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp.getKeys({keyList: ['space'], waitRelease: false});
      _key_resp_allKeys = _key_resp_allKeys.concat(theseKeys);
      if (_key_resp_allKeys.length > 0) {
        key_resp.keys = _key_resp_allKeys[_key_resp_allKeys.length - 1].name;  // just the last key pressed
        key_resp.rt = _key_resp_allKeys[_key_resp_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    A_StartComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function A_StartRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'A_Start'-------
    A_StartComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    psychoJS.experiment.addData('key_resp.keys', key_resp.keys);
    if (typeof key_resp.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp.rt', key_resp.rt);
        routineTimer.reset();
        }
    
    key_resp.stop();
    // the Routine "A_Start" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var gotValidClick;
var B_Consent1Components;
function B_Consent1RoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'B_Consent1'-------
    t = 0;
    B_Consent1Clock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // setup some python lists for storing info about the Mouse1
    Mouse1.clicked_name = [];
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    B_Consent1Components = [];
    B_Consent1Components.push(ConsentForm1);
    B_Consent1Components.push(Button1);
    B_Consent1Components.push(Mouse1);
    
    B_Consent1Components.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


var prevButtonState;
function B_Consent1RoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'B_Consent1'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = B_Consent1Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *ConsentForm1* updates
    if (frameN >= 0.0 && ConsentForm1.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      ConsentForm1.tStart = t;  // (not accounting for frame time here)
      ConsentForm1.frameNStart = frameN;  // exact frame index
      
      ConsentForm1.setAutoDraw(true);
    }

    
    // *Button1* updates
    if (frameN >= 0.0 && Button1.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Button1.tStart = t;  // (not accounting for frame time here)
      Button1.frameNStart = frameN;  // exact frame index
      
      Button1.setAutoDraw(true);
    }

    // *Mouse1* updates
    if (frameN >= 0.0 && Mouse1.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mouse1.tStart = t;  // (not accounting for frame time here)
      Mouse1.frameNStart = frameN;  // exact frame index
      
      Mouse1.status = PsychoJS.Status.STARTED;
      Mouse1.mouseClock.reset();
      prevButtonState = Mouse1.getPressed();  // if button is down already this ISN'T a new click
      }
    if (Mouse1.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      let buttons = Mouse1.getPressed();
      if (!buttons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = buttons;
        if (buttons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // check if the mouse was inside our 'clickable' objects
          gotValidClick = false;
          for (const obj of [Button1]) {
            if (obj.contains(Mouse1)) {
              gotValidClick = true;
              Mouse1.clicked_name.push(obj.name)
            }
          }
          if (gotValidClick === true) { // abort routine on response
            continueRoutine = false;
          }
        }
      }
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    B_Consent1Components.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function B_Consent1RoutineEnd(trials) {
  return function () {
    //------Ending Routine 'B_Consent1'-------
    B_Consent1Components.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for thisExp (ExperimentHandler)
    const xys = Mouse1.getPos();
    const buttons = Mouse1.getPressed();
    psychoJS.experiment.addData('Mouse1.x', xys[0]);
    psychoJS.experiment.addData('Mouse1.y', xys[1]);
    psychoJS.experiment.addData('Mouse1.leftButton', buttons[0]);
    psychoJS.experiment.addData('Mouse1.midButton', buttons[1]);
    psychoJS.experiment.addData('Mouse1.rightButton', buttons[2]);
    if (Mouse1.clicked_name.length > 0) {
      psychoJS.experiment.addData('Mouse1.clicked_name', Mouse1.clicked_name[0]);}
    // the Routine "B_Consent1" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var C_Consent2Components;
function C_Consent2RoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'C_Consent2'-------
    t = 0;
    C_Consent2Clock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // setup some python lists for storing info about the Mouse2
    Mouse2.clicked_name = [];
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    C_Consent2Components = [];
    C_Consent2Components.push(ConsentForm2);
    C_Consent2Components.push(Button2);
    C_Consent2Components.push(Mouse2);
    
    C_Consent2Components.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function C_Consent2RoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'C_Consent2'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = C_Consent2Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *ConsentForm2* updates
    if (frameN >= 0.0 && ConsentForm2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      ConsentForm2.tStart = t;  // (not accounting for frame time here)
      ConsentForm2.frameNStart = frameN;  // exact frame index
      
      ConsentForm2.setAutoDraw(true);
    }

    
    // *Button2* updates
    if (frameN >= 0.0 && Button2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Button2.tStart = t;  // (not accounting for frame time here)
      Button2.frameNStart = frameN;  // exact frame index
      
      Button2.setAutoDraw(true);
    }

    // *Mouse2* updates
    if (frameN >= 0.0 && Mouse2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mouse2.tStart = t;  // (not accounting for frame time here)
      Mouse2.frameNStart = frameN;  // exact frame index
      
      Mouse2.status = PsychoJS.Status.STARTED;
      Mouse2.mouseClock.reset();
      prevButtonState = Mouse2.getPressed();  // if button is down already this ISN'T a new click
      }
    if (Mouse2.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      let buttons = Mouse2.getPressed();
      if (!buttons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = buttons;
        if (buttons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // check if the mouse was inside our 'clickable' objects
          gotValidClick = false;
          for (const obj of [Button2]) {
            if (obj.contains(Mouse2)) {
              gotValidClick = true;
              Mouse2.clicked_name.push(obj.name)
            }
          }
          if (gotValidClick === true) { // abort routine on response
            continueRoutine = false;
          }
        }
      }
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    C_Consent2Components.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function C_Consent2RoutineEnd(trials) {
  return function () {
    //------Ending Routine 'C_Consent2'-------
    C_Consent2Components.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for thisExp (ExperimentHandler)
    // the Routine "C_Consent2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var D_Consent3Components;
function D_Consent3RoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'D_Consent3'-------
    t = 0;
    D_Consent3Clock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // setup some python lists for storing info about the Mouse3
    Mouse3.clicked_name = [];
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    D_Consent3Components = [];
    D_Consent3Components.push(ConsentForm3);
    D_Consent3Components.push(Button_Agree);
    D_Consent3Components.push(Button_Disagree);
    D_Consent3Components.push(Mouse3);
    
    D_Consent3Components.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function D_Consent3RoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'D_Consent3'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = D_Consent3Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *ConsentForm3* updates
    if (frameN >= 0.0 && ConsentForm3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      ConsentForm3.tStart = t;  // (not accounting for frame time here)
      ConsentForm3.frameNStart = frameN;  // exact frame index
      
      ConsentForm3.setAutoDraw(true);
    }

    
    // *Button_Agree* updates
    if (frameN >= 0.0 && Button_Agree.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Button_Agree.tStart = t;  // (not accounting for frame time here)
      Button_Agree.frameNStart = frameN;  // exact frame index
      
      Button_Agree.setAutoDraw(true);
    }

    
    // *Button_Disagree* updates
    if (frameN >= 0.0 && Button_Disagree.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Button_Disagree.tStart = t;  // (not accounting for frame time here)
      Button_Disagree.frameNStart = frameN;  // exact frame index
      
      Button_Disagree.setAutoDraw(true);
    }

    // *Mouse3* updates
    if (frameN >= 0.0 && Mouse3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mouse3.tStart = t;  // (not accounting for frame time here)
      Mouse3.frameNStart = frameN;  // exact frame index
      
      Mouse3.status = PsychoJS.Status.STARTED;
      Mouse3.mouseClock.reset();
      prevButtonState = Mouse3.getPressed();  // if button is down already this ISN'T a new click
      }
    if (Mouse3.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      let buttons = Mouse3.getPressed();
      if (!buttons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = buttons;
        if (buttons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // check if the mouse was inside our 'clickable' objects
          gotValidClick = false;
          for (const obj of [Button_Agree]) {
            if (obj.contains(Mouse3)) {
              gotValidClick = true;
              Mouse3.clicked_name.push(obj.name)
            }
          }
          if (gotValidClick === true) { // abort routine on response
            continueRoutine = false;
          }
        }
      }
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    D_Consent3Components.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function D_Consent3RoutineEnd(trials) {
  return function () {
    //------Ending Routine 'D_Consent3'-------
    D_Consent3Components.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for thisExp (ExperimentHandler)
    // the Routine "D_Consent3" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var E_VideoComponents;
function E_VideoRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'E_Video'-------
    t = 0;
    E_VideoClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // keep track of which components have finished
    E_VideoComponents = [];
    E_VideoComponents.push(movie);
    
    E_VideoComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function E_VideoRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'E_Video'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = E_VideoClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *movie* updates
    if (t >= 0.0 && movie.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      movie.tStart = t;  // (not accounting for frame time here)
      movie.frameNStart = frameN;  // exact frame index
      
      movie.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    E_VideoComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function E_VideoRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'E_Video'-------
    E_VideoComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "E_Video" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var trials;
var currentLoop;
function trialsLoopBegin(thisScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: undefined,
    seed: undefined, name: 'trials'
  });
  psychoJS.experiment.addLoop(trials); // add the loop to the experiment
  currentLoop = trials;  // we're now the current loop

  // Schedule all the trials in the trialList:
  trials.forEach(function() {
    const snapshot = trials.getSnapshot();

    thisScheduler.add(importConditions(snapshot));
    thisScheduler.add(F_ResponseRoutineBegin(snapshot));
    thisScheduler.add(F_ResponseRoutineEachFrame(snapshot));
    thisScheduler.add(F_ResponseRoutineEnd(snapshot));
    thisScheduler.add(endLoopIteration(thisScheduler, snapshot));
  });

  return Scheduler.Event.NEXT;
}


function trialsLoopEnd() {
  psychoJS.experiment.removeLoop(trials);

  return Scheduler.Event.NEXT;
}


var modify;
var F_ResponseComponents;
function F_ResponseRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'F_Response'-------
    t = 0;
    F_ResponseClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    modify = false;
    text.text = '';
    // keep track of which components have finished
    F_ResponseComponents = [];
    F_ResponseComponents.push(TextFrame);
    F_ResponseComponents.push(instr);
    F_ResponseComponents.push(text);
    
    F_ResponseComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


var textAdd;
function F_ResponseRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'F_Response'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = F_ResponseClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *TextFrame* updates
    if (t >= 0.0 && TextFrame.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      TextFrame.tStart = t;  // (not accounting for frame time here)
      TextFrame.frameNStart = frameN;  // exact frame index
      
      TextFrame.setAutoDraw(true);
    }

    
    // *instr* updates
    if (t >= 0.0 && instr.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      instr.tStart = t;  // (not accounting for frame time here)
      instr.frameNStart = frameN;  // exact frame index
      
      instr.setAutoDraw(true);
    }

    
    // *text* updates
    if (t >= 0.0 && text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text.tStart = t;  // (not accounting for frame time here)
      text.frameNStart = frameN;  // exact frame index
      
      text.setAutoDraw(true);
    }

    let theseKeys = psychoJS.eventManager.getKeys();
    if (theseKeys.length > 0) {  // at least one key was pressed
      textAdd = theseKeys[theseKeys.length-1]; 
      }
    
    
    if (textAdd === 'return') {
        textAdd = '';  // Add nothing
        continueRoutine = false;  // End routine (if that is what you want)
    } else if (textAdd === 'space') {
        textAdd = ' ';  // Add a space
    } else if (textAdd === 'backspace') {
        text.text = text.text.slice(0, -1);
        textAdd = undefined;
    } else if (['lshift', 'rshift'].includes(textAdd)) {
        modify = true;
    } else if (textAdd !== undefined) {
        if (modify) {
            text.text = text.text + textAdd.toUpperCase();
            modify = false;
        } else {
            text.text = text.text + textAdd
        }
        textAdd = undefined;
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    F_ResponseComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function F_ResponseRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'F_Response'-------
    F_ResponseComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    psychoJS.experiment.addData("typedWord", text.text)
    text.setText('')  // empty the onscreen text ready for next input
    // the Routine "F_Response" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var G_EndComponents;
function G_EndRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'G_End'-------
    t = 0;
    G_EndClock.reset(); // clock
    frameN = -1;
    routineTimer.add(5.000000);
    // update component parameters for each repeat
    // keep track of which components have finished
    G_EndComponents = [];
    G_EndComponents.push(text_2);
    
    G_EndComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


var frameRemains;
function G_EndRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'G_End'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = G_EndClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text_2* updates
    if (t >= 0.0 && text_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_2.tStart = t;  // (not accounting for frame time here)
      text_2.frameNStart = frameN;  // exact frame index
      
      text_2.setAutoDraw(true);
    }

    frameRemains = 0.0 + 5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (text_2.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      text_2.setAutoDraw(false);
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    G_EndComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine && routineTimer.getTime() > 0) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function G_EndRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'G_End'-------
    G_EndComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    return Scheduler.Event.NEXT;
  };
}


function endLoopIteration(thisScheduler, loop) {
  // ------Prepare for next entry------
  return function () {
    if (typeof loop !== 'undefined') {
      // ------Check if user ended loop early------
      if (loop.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(loop);
        }
      thisScheduler.stop();
      } else {
        const thisTrial = loop.getCurrentTrial();
        if (typeof thisTrial === 'undefined' || !('isTrials' in thisTrial) || thisTrial.isTrials) {
          psychoJS.experiment.nextEntry(loop);
        }
      }
    return Scheduler.Event.NEXT;
    }
  };
}


function importConditions(trials) {
  return function () {
    psychoJS.importAttributes(trials.getCurrentTrial());
    return Scheduler.Event.NEXT;
    };
}


function quitPsychoJS(message, isCompleted) {
  // Check for and save orphaned data
  if (psychoJS.experiment.isEntryEmpty()) {
    psychoJS.experiment.nextEntry();
  }
  
  
  
  
  
  
  
  
  psychoJS.window.close();
  psychoJS.quit({message: message, isCompleted: isCompleted});
  
  return Scheduler.Event.QUIT;
}
