﻿/****************** 
 * Illusion3 Test *
 ******************/

// init psychoJS:
const psychoJS = new PsychoJS({
  debug: true
});

// open window:
psychoJS.openWindow({
  fullscr: true,
  color: new util.Color([0, 0, 0]),
  units: 'height',
  waitBlanking: true
});

// store info about the experiment session:
let expName = 'Illusion3';  // from the Builder filename that created this script
let expInfo = {'participant': '', 'session': '001'};

// schedule the experiment:
psychoJS.schedule(psychoJS.gui.DlgFromDict({
  dictionary: expInfo,
  title: expName
}));

const flowScheduler = new Scheduler(psychoJS);
const dialogCancelScheduler = new Scheduler(psychoJS);
psychoJS.scheduleCondition(function() { return (psychoJS.gui.dialogComponent.button === 'OK'); }, flowScheduler, dialogCancelScheduler);

// flowScheduler gets run if the participants presses OK
flowScheduler.add(updateInfo); // add timeStamp
flowScheduler.add(experimentInit);
flowScheduler.add(A_StartRoutineBegin());
flowScheduler.add(A_StartRoutineEachFrame());
flowScheduler.add(A_StartRoutineEnd());
flowScheduler.add(B_Consent1RoutineBegin());
flowScheduler.add(B_Consent1RoutineEachFrame());
flowScheduler.add(B_Consent1RoutineEnd());
flowScheduler.add(C_Consent2RoutineBegin());
flowScheduler.add(C_Consent2RoutineEachFrame());
flowScheduler.add(C_Consent2RoutineEnd());
flowScheduler.add(D_Consent3RoutineBegin());
flowScheduler.add(D_Consent3RoutineEachFrame());
flowScheduler.add(D_Consent3RoutineEnd());
flowScheduler.add(E_VideoRoutineBegin());
flowScheduler.add(E_VideoRoutineEachFrame());
flowScheduler.add(E_VideoRoutineEnd());
const trialsLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(trialsLoopBegin, trialsLoopScheduler);
flowScheduler.add(trialsLoopScheduler);
flowScheduler.add(trialsLoopEnd);
flowScheduler.add(G_EndRoutineBegin());
flowScheduler.add(G_EndRoutineEachFrame());
flowScheduler.add(G_EndRoutineEnd());
flowScheduler.add(H_Debrief1RoutineBegin());
flowScheduler.add(H_Debrief1RoutineEachFrame());
flowScheduler.add(H_Debrief1RoutineEnd());
flowScheduler.add(I_Debrief2RoutineBegin());
flowScheduler.add(I_Debrief2RoutineEachFrame());
flowScheduler.add(I_Debrief2RoutineEnd());
flowScheduler.add(J_Debrief3RoutineBegin());
flowScheduler.add(J_Debrief3RoutineEachFrame());
flowScheduler.add(J_Debrief3RoutineEnd());
flowScheduler.add(quitPsychoJS, '', true);

// quit if user presses Cancel in dialog box:
dialogCancelScheduler.add(quitPsychoJS, '', false);

psychoJS.start({
  expName: expName,
  expInfo: expInfo,
  });


var frameDur;
function updateInfo() {
  expInfo['date'] = util.MonotonicClock.getDateStr();  // add a simple timestamp
  expInfo['expName'] = expName;
  expInfo['psychopyVersion'] = '2020.1.2';
  expInfo['OS'] = window.navigator.platform;

  // store frame rate of monitor if we can measure it successfully
  expInfo['frameRate'] = psychoJS.window.getActualFrameRate();
  if (typeof expInfo['frameRate'] !== 'undefined')
    frameDur = 1.0 / Math.round(expInfo['frameRate']);
  else
    frameDur = 1.0 / 60.0; // couldn't get a reliable measure so guess

  // add info from the URL:
  util.addInfoFromUrl(expInfo);
  
  return Scheduler.Event.NEXT;
}


var A_StartClock;
var instText;
var key_resp;
var VideoPath;
var Code;
var End_string;
var sBrowser;
var B_Consent1Clock;
var White_Background;
var ConsentForm1;
var Agree;
var Disagree;
var Mouse1;
var C_Consent2Clock;
var ConsentForm2;
var Button2;
var Mouse2;
var D_Consent3Clock;
var ConsentForm3;
var Button_Agree;
var Button_Disagree;
var Mouse3;
var E_VideoClock;
var F_ResponseClock;
var TextFrame;
var instr;
var text;
var G_EndClock;
var Thank_You;
var Text_Email;
var Mail_Example;
var Button_End;
var Mouse_End;
var H_Debrief1Clock;
var Debrief1;
var Button3;
var Mouse4;
var I_Debrief2Clock;
var Debrief2;
var Button4;
var Mouse5;
var J_Debrief3Clock;
var Debrief3;
var Mouse6;
var text_3;
var globalClock;
var routineTimer;
function experimentInit() {
  // Initialize components for Routine "A_Start"
  A_StartClock = new util.Clock();
  instText = new visual.TextStim({
    win: psychoJS.window,
    name: 'instText',
    text: 'In this demo, we show how you can use text components to write a users keyboard input on screen.\n\nInstructions.\n\nPress spacebar to continue...',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  key_resp = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  
  expInfo['OS'] = window.navigator.platform;
  
  var sUsrAg;
  var nIdx;
  function getBrowserId () {
      var browsers = ["MSIE", "Firefox", "Safari", "Chrome", "Opera"];
      sUsrAg = window.navigator.userAgent,
      nIdx = browsers.length - 1;
      for (nIdx; nIdx > -1 && sUsrAg.indexOf(browsers [nIdx]) === -1; nIdx--);
  
    return browsers[nIdx];
  }
  
  expInfo['OS'] = window.navigator.platform;
  expInfo['browser'] = getBrowserId();
  expInfo['xResolution'] = screen.width;
  expInfo['yResolution'] = screen.height;
  
  VideoPath = "Videos/FrameTEST2250.mp4";
  psychoJS.experiment.addData('VideoPath', VideoPath)
  
  Code = (Math.floor((Math.random() * ((1000 - 100) + 1))) + 100);
  psychoJS.experiment.addData('SubjCode', Code)
  
  End_string = ("YOUR PERSONAL CODE IS: " + Code.toString());
  
  
    $.getJSON('https://api.ipify.org?format=json', function(data){
  
      console.log(data.ip);
      localStorage.setItem('ip',data.ip);
  
      psychoJS.experiment.addData('IP_Addresss', data.ip)
  
    });
  
  
  
  if( /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) ) {
    quitPsychoJS('Mobile device detected. Goodbye!', false)
  }
  
  var sBrowser, sUsrAg = navigator.userAgent;
  
  // The order matters here, and this may report false positives for unlisted browsers.
  
  if (sUsrAg.indexOf("Firefox") > -1) {
    sBrowser = "Mozilla Firefox";
    // "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:61.0) Gecko/20100101 Firefox/61.0"
  } else if (sUsrAg.indexOf("SamsungBrowser") > -1) {
    sBrowser = "Samsung Internet";
    // "Mozilla/5.0 (Linux; Android 9; SAMSUNG SM-G955F Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.4 Chrome/67.0.3396.87 Mobile Safari/537.36
  } else if (sUsrAg.indexOf("Opera") > -1 || sUsrAg.indexOf("OPR") > -1) {
    sBrowser = "Opera";
    // "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 OPR/57.0.3098.106"
  } else if (sUsrAg.indexOf("Trident") > -1) {
    sBrowser = "Microsoft Internet Explorer";
    // "Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; Zoom 3.6.0; wbx 1.0.0; rv:11.0) like Gecko"
  } else if (sUsrAg.indexOf("Edge") > -1) {
    sBrowser = "Microsoft Edge";
    // "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299"
  } else if (sUsrAg.indexOf("Chrome") > -1) {
    sBrowser = "Google Chrome or Chromium";
    // "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/66.0.3359.181 Chrome/66.0.3359.181 Safari/537.36"
  } else if (sUsrAg.indexOf("Safari") > -1) {
    sBrowser = "Apple Safari";
    // "Mozilla/5.0 (iPhone; CPU iPhone OS 11_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.0 Mobile/15E148 Safari/604.1 980x1306"
  } else {
    sBrowser = "unknown";
  }
  
  psychoJS.experiment.addData('Browser', sBrowser)
  
  // Initialize components for Routine "B_Consent1"
  B_Consent1Clock = new util.Clock();
  White_Background = new visual.Rect ({
    win: psychoJS.window, name: 'White_Background', units : 'height', 
    width: [2, 1][0], height: [2, 1][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1.0, 1.0, 1.0]),
    opacity: 1, depth: 0, interpolate: true,
  });
  
  ConsentForm1 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'ConsentForm1', units : 'height', 
    image : 'Images/consent1.jpg', mask : undefined,
    ori : 0, pos : [0, 0], size : [1.4, 1],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -1.0 
  });
  Agree = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Agree', units : 'height', 
    image : 'Images/agree2.png', mask : undefined,
    ori : 0, pos : [0.7, (- 0.45)], size : [0.2, 0.1],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -2.0 
  });
  Disagree = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Disagree', units : 'height', 
    image : 'Images/disagree2.png', mask : undefined,
    ori : 0, pos : [(- 0.7), (- 0.45)], size : [0.2, 0.1],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -3.0 
  });
  Mouse1 = new core.Mouse({
    win: psychoJS.window,
  });
  Mouse1.mouseClock = new util.Clock();
  // Initialize components for Routine "C_Consent2"
  C_Consent2Clock = new util.Clock();
  ConsentForm2 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'ConsentForm2', units : 'height', 
    image : 'Images/consent2.jpg', mask : undefined,
    ori : 0, pos : [0, 0], size : [1.4, 0.7],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : 0.0 
  });
  Button2 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Button2', units : 'height', 
    image : 'Images/button.png', mask : undefined,
    ori : 0, pos : [0.65, (- 0.45)], size : [0.1, 0.045],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -1.0 
  });
  Mouse2 = new core.Mouse({
    win: psychoJS.window,
  });
  Mouse2.mouseClock = new util.Clock();
  // Initialize components for Routine "D_Consent3"
  D_Consent3Clock = new util.Clock();
  ConsentForm3 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'ConsentForm3', units : 'height', 
    image : 'Images/consent3.jpg', mask : undefined,
    ori : 0, pos : [0, 0], size : [1.4, 0.6],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : 0.0 
  });
  Button_Agree = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Button_Agree', units : 'height', 
    image : 'Images/agree.png', mask : undefined,
    ori : 0, pos : [(- 0.7), (- 0.45)], size : [0.15, 0.045],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -1.0 
  });
  Button_Disagree = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Button_Disagree', units : 'height', 
    image : 'Images/disagree.png', mask : undefined,
    ori : 0, pos : [0.7, (- 0.45)], size : [0.15, 0.045],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -2.0 
  });
  Mouse3 = new core.Mouse({
    win: psychoJS.window,
  });
  Mouse3.mouseClock = new util.Clock();
  // Initialize components for Routine "E_Video"
  E_VideoClock = new util.Clock();
  // Initialize components for Routine "F_Response"
  F_ResponseClock = new util.Clock();
  TextFrame = new visual.Rect ({
    win: psychoJS.window, name: 'TextFrame', units : 'height', 
    width: [0.5, 0.15][0], height: [0.5, 0.15][1],
    ori: 0, pos: [0, 0],
    lineWidth: 15, lineColor: new util.Color([(- 1), (- 1), (- 1)]),
    fillColor: new util.Color([0, 0, 0]),
    opacity: 1, depth: 0, interpolate: true,
  });
  
  instr = new visual.TextStim({
    win: psychoJS.window,
    name: 'instr',
    text: 'Type the answer in the frame below, \nand press RETURN\n(text will appear when you type)',
    font: 'Arial',
    units: 'norm', 
    pos: [0, 0.5], height: 0.1,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -1.0 
  });
  
  text = new visual.TextStim({
    win: psychoJS.window,
    name: 'text',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.1,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -2.0 
  });
  
  // Initialize components for Routine "G_End"
  G_EndClock = new util.Clock();
  Thank_You = new visual.TextStim({
    win: psychoJS.window,
    name: 'Thank_You',
    text: 'In order to complete the survey,\nplease send an email to mauromanassi@gmail.com\nwith your Name and Surname in the Subject,\nfollowed by the code below (in black):\n\n\n\n\n\n\n\nAfter you have sent the email, please click on the NEXT button for the Debrief form\n(or close the browser tab now)',
    font: 'Arial',
    units: 'height', 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  Text_Email = new visual.TextStim({
    win: psychoJS.window,
    name: 'Text_Email',
    text: End_string,
    font: 'Arial',
    units: 'height', 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('black'),  opacity: 1,
    depth: -1.0 
  });
  
  Mail_Example = new visual.TextStim({
    win: psychoJS.window,
    name: 'Mail_Example',
    text: '\n\n\n\n\n\n\n(Mail Subject Example: Mauro Manassi Code 568)\n',
    font: 'Arial',
    units: 'height', 
    pos: [0, 0], height: 0.04,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -2.0 
  });
  
  Button_End = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Button_End', units : 'height', 
    image : 'Images/button.png', mask : undefined,
    ori : 0, pos : [0.65, (- 0.45)], size : [0.1, 0.045],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -3.0 
  });
  Mouse_End = new core.Mouse({
    win: psychoJS.window,
  });
  Mouse_End.mouseClock = new util.Clock();
  // Initialize components for Routine "H_Debrief1"
  H_Debrief1Clock = new util.Clock();
  Debrief1 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Debrief1', units : 'height', 
    image : 'Images/consent1.jpg', mask : undefined,
    ori : 0, pos : [0, 0], size : [1.4, 1.0],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : 0.0 
  });
  Button3 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Button3', units : 'height', 
    image : 'Images/button.png', mask : undefined,
    ori : 0, pos : [0.65, (- 0.45)], size : [0.1, 0.045],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -1.0 
  });
  Mouse4 = new core.Mouse({
    win: psychoJS.window,
  });
  Mouse4.mouseClock = new util.Clock();
  // Initialize components for Routine "I_Debrief2"
  I_Debrief2Clock = new util.Clock();
  Debrief2 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Debrief2', units : 'height', 
    image : 'Images/consent1.jpg', mask : undefined,
    ori : 0, pos : [0, 0], size : [1.4, 0.7],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : 0.0 
  });
  Button4 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Button4', units : 'height', 
    image : 'Images/button.png', mask : undefined,
    ori : 0, pos : [0.65, (- 0.45)], size : [0.1, 0.045],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -1.0 
  });
  Mouse5 = new core.Mouse({
    win: psychoJS.window,
  });
  Mouse5.mouseClock = new util.Clock();
  // Initialize components for Routine "J_Debrief3"
  J_Debrief3Clock = new util.Clock();
  Debrief3 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Debrief3', units : 'height', 
    image : 'Images/consent3.jpg', mask : undefined,
    ori : 0, pos : [0, 0], size : [1.4, 0.6],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : 0.0 
  });
  Mouse6 = new core.Mouse({
    win: psychoJS.window,
  });
  Mouse6.mouseClock = new util.Clock();
  text_3 = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_3',
    text: 'Thank you for participating!\n(You can close the browser now)',
    font: 'Arial',
    units: 'height', 
    pos: [0, (- 0.4)], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -2.0 
  });
  
  // Create some handy timers
  globalClock = new util.Clock();  // to track the time since experiment started
  routineTimer = new util.CountdownTimer();  // to track time remaining of each (non-slip) routine
  
  return Scheduler.Event.NEXT;
}


var t;
var frameN;
var _key_resp_allKeys;
var A_StartComponents;
function A_StartRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'A_Start'-------
    t = 0;
    A_StartClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    key_resp.keys = undefined;
    key_resp.rt = undefined;
    _key_resp_allKeys = [];
    // keep track of which components have finished
    A_StartComponents = [];
    A_StartComponents.push(instText);
    A_StartComponents.push(key_resp);
    
    A_StartComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


var continueRoutine;
function A_StartRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'A_Start'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = A_StartClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *instText* updates
    if (t >= 0.0 && instText.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      instText.tStart = t;  // (not accounting for frame time here)
      instText.frameNStart = frameN;  // exact frame index
      
      instText.setAutoDraw(true);
    }

    
    // *key_resp* updates
    if (t >= 0.0 && key_resp.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp.tStart = t;  // (not accounting for frame time here)
      key_resp.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp.clearEvents(); });
    }

    if (key_resp.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp.getKeys({keyList: ['space'], waitRelease: false});
      _key_resp_allKeys = _key_resp_allKeys.concat(theseKeys);
      if (_key_resp_allKeys.length > 0) {
        key_resp.keys = _key_resp_allKeys[_key_resp_allKeys.length - 1].name;  // just the last key pressed
        key_resp.rt = _key_resp_allKeys[_key_resp_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    A_StartComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function A_StartRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'A_Start'-------
    A_StartComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    psychoJS.experiment.addData('key_resp.keys', key_resp.keys);
    if (typeof key_resp.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp.rt', key_resp.rt);
        routineTimer.reset();
        }
    
    key_resp.stop();
    // the Routine "A_Start" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var gotValidClick;
var B_Consent1Components;
function B_Consent1RoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'B_Consent1'-------
    t = 0;
    B_Consent1Clock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // setup some python lists for storing info about the Mouse1
    Mouse1.clicked_name = [];
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    B_Consent1Components = [];
    B_Consent1Components.push(White_Background);
    B_Consent1Components.push(ConsentForm1);
    B_Consent1Components.push(Agree);
    B_Consent1Components.push(Disagree);
    B_Consent1Components.push(Mouse1);
    
    B_Consent1Components.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


var prevButtonState;
function B_Consent1RoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'B_Consent1'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = B_Consent1Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *White_Background* updates
    if (frameN >= 0.0 && White_Background.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      White_Background.tStart = t;  // (not accounting for frame time here)
      White_Background.frameNStart = frameN;  // exact frame index
      
      White_Background.setAutoDraw(true);
    }

    
    // *ConsentForm1* updates
    if (frameN >= 0.0 && ConsentForm1.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      ConsentForm1.tStart = t;  // (not accounting for frame time here)
      ConsentForm1.frameNStart = frameN;  // exact frame index
      
      ConsentForm1.setAutoDraw(true);
    }

    
    // *Agree* updates
    if (frameN >= 0.0 && Agree.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Agree.tStart = t;  // (not accounting for frame time here)
      Agree.frameNStart = frameN;  // exact frame index
      
      Agree.setAutoDraw(true);
    }

    
    // *Disagree* updates
    if (frameN >= 0.0 && Disagree.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Disagree.tStart = t;  // (not accounting for frame time here)
      Disagree.frameNStart = frameN;  // exact frame index
      
      Disagree.setAutoDraw(true);
    }

    // *Mouse1* updates
    if (frameN >= 0.0 && Mouse1.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mouse1.tStart = t;  // (not accounting for frame time here)
      Mouse1.frameNStart = frameN;  // exact frame index
      
      Mouse1.status = PsychoJS.Status.STARTED;
      Mouse1.mouseClock.reset();
      prevButtonState = Mouse1.getPressed();  // if button is down already this ISN'T a new click
      }
    if (Mouse1.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      let buttons = Mouse1.getPressed();
      if (!buttons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = buttons;
        if (buttons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // check if the mouse was inside our 'clickable' objects
          gotValidClick = false;
          for (const obj of [Agree]) {
            if (obj.contains(Mouse1)) {
              gotValidClick = true;
              Mouse1.clicked_name.push(obj.name)
            }
          }
          if (gotValidClick === true) { // abort routine on response
            continueRoutine = false;
          }
        }
      }
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    B_Consent1Components.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function B_Consent1RoutineEnd(trials) {
  return function () {
    //------Ending Routine 'B_Consent1'-------
    B_Consent1Components.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for thisExp (ExperimentHandler)
    const xys = Mouse1.getPos();
    const buttons = Mouse1.getPressed();
    psychoJS.experiment.addData('Mouse1.x', xys[0]);
    psychoJS.experiment.addData('Mouse1.y', xys[1]);
    psychoJS.experiment.addData('Mouse1.leftButton', buttons[0]);
    psychoJS.experiment.addData('Mouse1.midButton', buttons[1]);
    psychoJS.experiment.addData('Mouse1.rightButton', buttons[2]);
    if (Mouse1.clicked_name.length > 0) {
      psychoJS.experiment.addData('Mouse1.clicked_name', Mouse1.clicked_name[0]);}
    // the Routine "B_Consent1" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var C_Consent2Components;
function C_Consent2RoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'C_Consent2'-------
    t = 0;
    C_Consent2Clock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // setup some python lists for storing info about the Mouse2
    Mouse2.clicked_name = [];
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    C_Consent2Components = [];
    C_Consent2Components.push(ConsentForm2);
    C_Consent2Components.push(Button2);
    C_Consent2Components.push(Mouse2);
    
    C_Consent2Components.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function C_Consent2RoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'C_Consent2'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = C_Consent2Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *ConsentForm2* updates
    if (frameN >= 0.0 && ConsentForm2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      ConsentForm2.tStart = t;  // (not accounting for frame time here)
      ConsentForm2.frameNStart = frameN;  // exact frame index
      
      ConsentForm2.setAutoDraw(true);
    }

    
    // *Button2* updates
    if (frameN >= 0.0 && Button2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Button2.tStart = t;  // (not accounting for frame time here)
      Button2.frameNStart = frameN;  // exact frame index
      
      Button2.setAutoDraw(true);
    }

    // *Mouse2* updates
    if (frameN >= 0.0 && Mouse2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mouse2.tStart = t;  // (not accounting for frame time here)
      Mouse2.frameNStart = frameN;  // exact frame index
      
      Mouse2.status = PsychoJS.Status.STARTED;
      Mouse2.mouseClock.reset();
      prevButtonState = Mouse2.getPressed();  // if button is down already this ISN'T a new click
      }
    if (Mouse2.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      let buttons = Mouse2.getPressed();
      if (!buttons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = buttons;
        if (buttons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // check if the mouse was inside our 'clickable' objects
          gotValidClick = false;
          for (const obj of [Button2]) {
            if (obj.contains(Mouse2)) {
              gotValidClick = true;
              Mouse2.clicked_name.push(obj.name)
            }
          }
          if (gotValidClick === true) { // abort routine on response
            continueRoutine = false;
          }
        }
      }
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    C_Consent2Components.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function C_Consent2RoutineEnd(trials) {
  return function () {
    //------Ending Routine 'C_Consent2'-------
    C_Consent2Components.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for thisExp (ExperimentHandler)
    // the Routine "C_Consent2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var D_Consent3Components;
function D_Consent3RoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'D_Consent3'-------
    t = 0;
    D_Consent3Clock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // setup some python lists for storing info about the Mouse3
    Mouse3.clicked_name = [];
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    D_Consent3Components = [];
    D_Consent3Components.push(ConsentForm3);
    D_Consent3Components.push(Button_Agree);
    D_Consent3Components.push(Button_Disagree);
    D_Consent3Components.push(Mouse3);
    
    D_Consent3Components.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function D_Consent3RoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'D_Consent3'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = D_Consent3Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *ConsentForm3* updates
    if (frameN >= 0.0 && ConsentForm3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      ConsentForm3.tStart = t;  // (not accounting for frame time here)
      ConsentForm3.frameNStart = frameN;  // exact frame index
      
      ConsentForm3.setAutoDraw(true);
    }

    
    // *Button_Agree* updates
    if (frameN >= 0.0 && Button_Agree.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Button_Agree.tStart = t;  // (not accounting for frame time here)
      Button_Agree.frameNStart = frameN;  // exact frame index
      
      Button_Agree.setAutoDraw(true);
    }

    
    // *Button_Disagree* updates
    if (frameN >= 0.0 && Button_Disagree.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Button_Disagree.tStart = t;  // (not accounting for frame time here)
      Button_Disagree.frameNStart = frameN;  // exact frame index
      
      Button_Disagree.setAutoDraw(true);
    }

    // *Mouse3* updates
    if (frameN >= 0.0 && Mouse3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mouse3.tStart = t;  // (not accounting for frame time here)
      Mouse3.frameNStart = frameN;  // exact frame index
      
      Mouse3.status = PsychoJS.Status.STARTED;
      Mouse3.mouseClock.reset();
      prevButtonState = Mouse3.getPressed();  // if button is down already this ISN'T a new click
      }
    if (Mouse3.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      let buttons = Mouse3.getPressed();
      if (!buttons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = buttons;
        if (buttons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // check if the mouse was inside our 'clickable' objects
          gotValidClick = false;
          for (const obj of [Button_Agree]) {
            if (obj.contains(Mouse3)) {
              gotValidClick = true;
              Mouse3.clicked_name.push(obj.name)
            }
          }
          if (gotValidClick === true) { // abort routine on response
            continueRoutine = false;
          }
        }
      }
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    D_Consent3Components.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function D_Consent3RoutineEnd(trials) {
  return function () {
    //------Ending Routine 'D_Consent3'-------
    D_Consent3Components.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for thisExp (ExperimentHandler)
    // the Routine "D_Consent3" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var E_VideoComponents;
function E_VideoRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'E_Video'-------
    t = 0;
    E_VideoClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // keep track of which components have finished
    E_VideoComponents = [];
    
    E_VideoComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function E_VideoRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'E_Video'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = E_VideoClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    E_VideoComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function E_VideoRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'E_Video'-------
    E_VideoComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "E_Video" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var trials;
var currentLoop;
function trialsLoopBegin(thisScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: undefined,
    seed: undefined, name: 'trials'
  });
  psychoJS.experiment.addLoop(trials); // add the loop to the experiment
  currentLoop = trials;  // we're now the current loop

  // Schedule all the trials in the trialList:
  trials.forEach(function() {
    const snapshot = trials.getSnapshot();

    thisScheduler.add(importConditions(snapshot));
    thisScheduler.add(F_ResponseRoutineBegin(snapshot));
    thisScheduler.add(F_ResponseRoutineEachFrame(snapshot));
    thisScheduler.add(F_ResponseRoutineEnd(snapshot));
    thisScheduler.add(endLoopIteration(thisScheduler, snapshot));
  });

  return Scheduler.Event.NEXT;
}


function trialsLoopEnd() {
  psychoJS.experiment.removeLoop(trials);

  return Scheduler.Event.NEXT;
}


var modify;
var F_ResponseComponents;
function F_ResponseRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'F_Response'-------
    t = 0;
    F_ResponseClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    modify = false;
    text.text = '';
    // keep track of which components have finished
    F_ResponseComponents = [];
    F_ResponseComponents.push(TextFrame);
    F_ResponseComponents.push(instr);
    F_ResponseComponents.push(text);
    
    F_ResponseComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


var textAdd;
function F_ResponseRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'F_Response'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = F_ResponseClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *TextFrame* updates
    if (t >= 0.0 && TextFrame.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      TextFrame.tStart = t;  // (not accounting for frame time here)
      TextFrame.frameNStart = frameN;  // exact frame index
      
      TextFrame.setAutoDraw(true);
    }

    
    // *instr* updates
    if (t >= 0.0 && instr.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      instr.tStart = t;  // (not accounting for frame time here)
      instr.frameNStart = frameN;  // exact frame index
      
      instr.setAutoDraw(true);
    }

    
    // *text* updates
    if (t >= 0.0 && text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text.tStart = t;  // (not accounting for frame time here)
      text.frameNStart = frameN;  // exact frame index
      
      text.setAutoDraw(true);
    }

    let theseKeys = psychoJS.eventManager.getKeys();
    if (theseKeys.length > 0) {  // at least one key was pressed
      textAdd = theseKeys[theseKeys.length-1]; 
      }
    
    
    if (textAdd === 'return') {
        textAdd = '';  // Add nothing
        continueRoutine = false;  // End routine (if that is what you want)
    } else if (textAdd === 'space') {
        textAdd = ' ';  // Add a space
    } else if (textAdd === 'backspace') {
        text.text = text.text.slice(0, -1);
        textAdd = undefined;
    } else if (['lshift', 'rshift'].includes(textAdd)) {
        modify = true;
    } else if (textAdd !== undefined) {
        if (modify) {
            text.text = text.text + textAdd.toUpperCase();
            modify = false;
        } else {
            text.text = text.text + textAdd
        }
        textAdd = undefined;
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    F_ResponseComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function F_ResponseRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'F_Response'-------
    F_ResponseComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    psychoJS.experiment.addData("typedWord", text.text)
    text.setText('')  // empty the onscreen text ready for next input
    // the Routine "F_Response" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var G_EndComponents;
function G_EndRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'G_End'-------
    t = 0;
    G_EndClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // setup some python lists for storing info about the Mouse_End
    Mouse_End.clicked_name = [];
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    G_EndComponents = [];
    G_EndComponents.push(Thank_You);
    G_EndComponents.push(Text_Email);
    G_EndComponents.push(Mail_Example);
    G_EndComponents.push(Button_End);
    G_EndComponents.push(Mouse_End);
    
    G_EndComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function G_EndRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'G_End'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = G_EndClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *Thank_You* updates
    if (t >= 0.0 && Thank_You.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Thank_You.tStart = t;  // (not accounting for frame time here)
      Thank_You.frameNStart = frameN;  // exact frame index
      
      Thank_You.setAutoDraw(true);
    }

    
    // *Text_Email* updates
    if (frameN >= 0.0 && Text_Email.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Text_Email.tStart = t;  // (not accounting for frame time here)
      Text_Email.frameNStart = frameN;  // exact frame index
      
      Text_Email.setAutoDraw(true);
    }

    
    // *Mail_Example* updates
    if (frameN >= 0.0 && Mail_Example.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mail_Example.tStart = t;  // (not accounting for frame time here)
      Mail_Example.frameNStart = frameN;  // exact frame index
      
      Mail_Example.setAutoDraw(true);
    }

    
    // *Button_End* updates
    if (frameN >= 0.0 && Button_End.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Button_End.tStart = t;  // (not accounting for frame time here)
      Button_End.frameNStart = frameN;  // exact frame index
      
      Button_End.setAutoDraw(true);
    }

    // *Mouse_End* updates
    if (frameN >= 0.0 && Mouse_End.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mouse_End.tStart = t;  // (not accounting for frame time here)
      Mouse_End.frameNStart = frameN;  // exact frame index
      
      Mouse_End.status = PsychoJS.Status.STARTED;
      Mouse_End.mouseClock.reset();
      prevButtonState = Mouse_End.getPressed();  // if button is down already this ISN'T a new click
      }
    if (Mouse_End.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      let buttons = Mouse_End.getPressed();
      if (!buttons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = buttons;
        if (buttons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // check if the mouse was inside our 'clickable' objects
          gotValidClick = false;
          for (const obj of [Button_End]) {
            if (obj.contains(Mouse_End)) {
              gotValidClick = true;
              Mouse_End.clicked_name.push(obj.name)
            }
          }
          if (gotValidClick === true) { // abort routine on response
            continueRoutine = false;
          }
        }
      }
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    G_EndComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function G_EndRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'G_End'-------
    G_EndComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for thisExp (ExperimentHandler)
    const xys = Mouse_End.getPos();
    const buttons = Mouse_End.getPressed();
    psychoJS.experiment.addData('Mouse_End.x', xys[0]);
    psychoJS.experiment.addData('Mouse_End.y', xys[1]);
    psychoJS.experiment.addData('Mouse_End.leftButton', buttons[0]);
    psychoJS.experiment.addData('Mouse_End.midButton', buttons[1]);
    psychoJS.experiment.addData('Mouse_End.rightButton', buttons[2]);
    if (Mouse_End.clicked_name.length > 0) {
      psychoJS.experiment.addData('Mouse_End.clicked_name', Mouse_End.clicked_name[0]);}
    // the Routine "G_End" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var H_Debrief1Components;
function H_Debrief1RoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'H_Debrief1'-------
    t = 0;
    H_Debrief1Clock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // setup some python lists for storing info about the Mouse4
    Mouse4.clicked_name = [];
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    H_Debrief1Components = [];
    H_Debrief1Components.push(Debrief1);
    H_Debrief1Components.push(Button3);
    H_Debrief1Components.push(Mouse4);
    
    H_Debrief1Components.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function H_Debrief1RoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'H_Debrief1'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = H_Debrief1Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *Debrief1* updates
    if (frameN >= 0.0 && Debrief1.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Debrief1.tStart = t;  // (not accounting for frame time here)
      Debrief1.frameNStart = frameN;  // exact frame index
      
      Debrief1.setAutoDraw(true);
    }

    
    // *Button3* updates
    if (frameN >= 0.0 && Button3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Button3.tStart = t;  // (not accounting for frame time here)
      Button3.frameNStart = frameN;  // exact frame index
      
      Button3.setAutoDraw(true);
    }

    // *Mouse4* updates
    if (frameN >= 0.0 && Mouse4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mouse4.tStart = t;  // (not accounting for frame time here)
      Mouse4.frameNStart = frameN;  // exact frame index
      
      Mouse4.status = PsychoJS.Status.STARTED;
      Mouse4.mouseClock.reset();
      prevButtonState = Mouse4.getPressed();  // if button is down already this ISN'T a new click
      }
    if (Mouse4.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      let buttons = Mouse4.getPressed();
      if (!buttons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = buttons;
        if (buttons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // check if the mouse was inside our 'clickable' objects
          gotValidClick = false;
          for (const obj of [Button3]) {
            if (obj.contains(Mouse4)) {
              gotValidClick = true;
              Mouse4.clicked_name.push(obj.name)
            }
          }
          if (gotValidClick === true) { // abort routine on response
            continueRoutine = false;
          }
        }
      }
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    H_Debrief1Components.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function H_Debrief1RoutineEnd(trials) {
  return function () {
    //------Ending Routine 'H_Debrief1'-------
    H_Debrief1Components.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for thisExp (ExperimentHandler)
    const xys = Mouse4.getPos();
    const buttons = Mouse4.getPressed();
    psychoJS.experiment.addData('Mouse4.x', xys[0]);
    psychoJS.experiment.addData('Mouse4.y', xys[1]);
    psychoJS.experiment.addData('Mouse4.leftButton', buttons[0]);
    psychoJS.experiment.addData('Mouse4.midButton', buttons[1]);
    psychoJS.experiment.addData('Mouse4.rightButton', buttons[2]);
    if (Mouse4.clicked_name.length > 0) {
      psychoJS.experiment.addData('Mouse4.clicked_name', Mouse4.clicked_name[0]);}
    // the Routine "H_Debrief1" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var I_Debrief2Components;
function I_Debrief2RoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'I_Debrief2'-------
    t = 0;
    I_Debrief2Clock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // setup some python lists for storing info about the Mouse5
    Mouse5.clicked_name = [];
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    I_Debrief2Components = [];
    I_Debrief2Components.push(Debrief2);
    I_Debrief2Components.push(Button4);
    I_Debrief2Components.push(Mouse5);
    
    I_Debrief2Components.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function I_Debrief2RoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'I_Debrief2'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = I_Debrief2Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *Debrief2* updates
    if (frameN >= 0.0 && Debrief2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Debrief2.tStart = t;  // (not accounting for frame time here)
      Debrief2.frameNStart = frameN;  // exact frame index
      
      Debrief2.setAutoDraw(true);
    }

    
    // *Button4* updates
    if (frameN >= 0.0 && Button4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Button4.tStart = t;  // (not accounting for frame time here)
      Button4.frameNStart = frameN;  // exact frame index
      
      Button4.setAutoDraw(true);
    }

    // *Mouse5* updates
    if (frameN >= 0.0 && Mouse5.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mouse5.tStart = t;  // (not accounting for frame time here)
      Mouse5.frameNStart = frameN;  // exact frame index
      
      Mouse5.status = PsychoJS.Status.STARTED;
      Mouse5.mouseClock.reset();
      prevButtonState = Mouse5.getPressed();  // if button is down already this ISN'T a new click
      }
    if (Mouse5.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      let buttons = Mouse5.getPressed();
      if (!buttons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = buttons;
        if (buttons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // check if the mouse was inside our 'clickable' objects
          gotValidClick = false;
          for (const obj of [Button4]) {
            if (obj.contains(Mouse5)) {
              gotValidClick = true;
              Mouse5.clicked_name.push(obj.name)
            }
          }
          if (gotValidClick === true) { // abort routine on response
            continueRoutine = false;
          }
        }
      }
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    I_Debrief2Components.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function I_Debrief2RoutineEnd(trials) {
  return function () {
    //------Ending Routine 'I_Debrief2'-------
    I_Debrief2Components.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for thisExp (ExperimentHandler)
    const xys = Mouse5.getPos();
    const buttons = Mouse5.getPressed();
    psychoJS.experiment.addData('Mouse5.x', xys[0]);
    psychoJS.experiment.addData('Mouse5.y', xys[1]);
    psychoJS.experiment.addData('Mouse5.leftButton', buttons[0]);
    psychoJS.experiment.addData('Mouse5.midButton', buttons[1]);
    psychoJS.experiment.addData('Mouse5.rightButton', buttons[2]);
    if (Mouse5.clicked_name.length > 0) {
      psychoJS.experiment.addData('Mouse5.clicked_name', Mouse5.clicked_name[0]);}
    // the Routine "I_Debrief2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var J_Debrief3Components;
function J_Debrief3RoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'J_Debrief3'-------
    t = 0;
    J_Debrief3Clock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    // setup some python lists for storing info about the Mouse6
    gotValidClick = false; // until a click is received
    // keep track of which components have finished
    J_Debrief3Components = [];
    J_Debrief3Components.push(Debrief3);
    J_Debrief3Components.push(Mouse6);
    J_Debrief3Components.push(text_3);
    
    J_Debrief3Components.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function J_Debrief3RoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'J_Debrief3'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = J_Debrief3Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *Debrief3* updates
    if (frameN >= 0.0 && Debrief3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Debrief3.tStart = t;  // (not accounting for frame time here)
      Debrief3.frameNStart = frameN;  // exact frame index
      
      Debrief3.setAutoDraw(true);
    }

    // *Mouse6* updates
    if (frameN >= 0.0 && Mouse6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Mouse6.tStart = t;  // (not accounting for frame time here)
      Mouse6.frameNStart = frameN;  // exact frame index
      
      Mouse6.status = PsychoJS.Status.STARTED;
      Mouse6.mouseClock.reset();
      prevButtonState = Mouse6.getPressed();  // if button is down already this ISN'T a new click
      }
    if (Mouse6.status === PsychoJS.Status.STARTED) {  // only update if started and not finished!
      let buttons = Mouse6.getPressed();
      if (!buttons.every( (e,i,) => (e == prevButtonState[i]) )) { // button state changed?
        prevButtonState = buttons;
        if (buttons.reduce( (e, acc) => (e+acc) ) > 0) { // state changed to a new click
          // abort routine on response
          continueRoutine = false;
        }
      }
    }
    
    // *text_3* updates
    if (t >= 0.0 && text_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_3.tStart = t;  // (not accounting for frame time here)
      text_3.frameNStart = frameN;  // exact frame index
      
      text_3.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    J_Debrief3Components.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function J_Debrief3RoutineEnd(trials) {
  return function () {
    //------Ending Routine 'J_Debrief3'-------
    J_Debrief3Components.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // store data for thisExp (ExperimentHandler)
    const xys = Mouse6.getPos();
    const buttons = Mouse6.getPressed();
    psychoJS.experiment.addData('Mouse6.x', xys[0]);
    psychoJS.experiment.addData('Mouse6.y', xys[1]);
    psychoJS.experiment.addData('Mouse6.leftButton', buttons[0]);
    psychoJS.experiment.addData('Mouse6.midButton', buttons[1]);
    psychoJS.experiment.addData('Mouse6.rightButton', buttons[2]);
    // the Routine "J_Debrief3" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


function endLoopIteration(thisScheduler, loop) {
  // ------Prepare for next entry------
  return function () {
    if (typeof loop !== 'undefined') {
      // ------Check if user ended loop early------
      if (loop.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(loop);
        }
      thisScheduler.stop();
      } else {
        const thisTrial = loop.getCurrentTrial();
        if (typeof thisTrial === 'undefined' || !('isTrials' in thisTrial) || thisTrial.isTrials) {
          psychoJS.experiment.nextEntry(loop);
        }
      }
    return Scheduler.Event.NEXT;
    }
  };
}


function importConditions(trials) {
  return function () {
    psychoJS.importAttributes(trials.getCurrentTrial());
    return Scheduler.Event.NEXT;
    };
}


function quitPsychoJS(message, isCompleted) {
  // Check for and save orphaned data
  if (psychoJS.experiment.isEntryEmpty()) {
    psychoJS.experiment.nextEntry();
  }
  
  
  
  
  
  
  
  
  
  
  
  
  psychoJS.window.close();
  psychoJS.quit({message: message, isCompleted: isCompleted});
  
  return Scheduler.Event.QUIT;
}
