﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2020.1.2),
    on Thu Apr  9 15:31:39 2020
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from __future__ import absolute_import, division

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding

from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)

# Store info about the experiment session
psychopyVersion = '2020.1.2'
expName = 'inputText2'  # from the Builder filename that created this script
expInfo = {'participant': '', 'session': '001'}
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='/Users/mauromanassi/Google Drive/PSYCHOPY ILLUSION/Illusion_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(
    size=[1920, 1080], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard()

# Initialize components for Routine "A_Start"
A_StartClock = core.Clock()
instText = visual.TextStim(win=win, name='instText',
    text='In this demo, we show how you can use text components to write a users keyboard input on screen.\n\nYou will be presented with a target word. Then, in the next routine, you will be asked to type that word.\nWhen you have finished typing the word, press "return" to end the trial.\n\n\nPress spacebar to continue...',
    font='Arial',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
key_resp = keyboard.Keyboard()
VideoPath = 'Videos/FrameTEST2250.mp4'
#thisExp.addData('VideoPath',VideoPath)




# Initialize components for Routine "B_Consent1"
B_Consent1Clock = core.Clock()
ConsentForm1 = visual.ImageStim(
    win=win,
    name='ConsentForm1', units='height', 
    image='Images/consent1.jpg', mask=None,
    ori=0, pos=(0, 0), size=(1.4, 1.0),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)
Button1 = visual.ImageStim(
    win=win,
    name='Button1', units='height', 
    image='Images/button.png', mask=None,
    ori=0, pos=(0.65, -0.45), size=(0.1, 0.045),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)
Mouse1 = event.Mouse(win=win)
x, y = [None, None]
Mouse1.mouseClock = core.Clock()

# Initialize components for Routine "C_Consent2"
C_Consent2Clock = core.Clock()
ConsentForm2 = visual.ImageStim(
    win=win,
    name='ConsentForm2', units='height', 
    image='Images/consent2.jpg', mask=None,
    ori=0, pos=(0, 0), size=(1.4, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)
Button2 = visual.ImageStim(
    win=win,
    name='Button2', units='height', 
    image='Images/button.png', mask=None,
    ori=0, pos=(0.65, -0.45), size=(0.1, 0.045),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)
Mouse2 = event.Mouse(win=win)
x, y = [None, None]
Mouse2.mouseClock = core.Clock()

# Initialize components for Routine "D_Consent3"
D_Consent3Clock = core.Clock()
ConsentForm3 = visual.ImageStim(
    win=win,
    name='ConsentForm3', units='height', 
    image='Images/consent3.jpg', mask=None,
    ori=0, pos=(0, 0), size=(1.4, 0.6),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)
Button_Agree = visual.ImageStim(
    win=win,
    name='Button_Agree', units='height', 
    image='Images/agree.png', mask=None,
    ori=0, pos=(-0.7, -0.45), size=(0.15, 0.045),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)
Button_Disagree = visual.ImageStim(
    win=win,
    name='Button_Disagree', units='height', 
    image='Images/disagree.png', mask=None,
    ori=0, pos=(0.7, -0.45), size=(0.15, 0.045),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-2.0)
Mouse3 = event.Mouse(win=win)
x, y = [None, None]
Mouse3.mouseClock = core.Clock()

# Initialize components for Routine "E_Video"
E_VideoClock = core.Clock()
movie = visual.MovieStim3(
    win=win, name='movie',units='height', 
    noAudio = True,
    filename=VideoPath,
    ori=0, pos=(0, 0), opacity=1,
    loop=False,
    size=[1.6,1],
    depth=0.0,
    )

# Initialize components for Routine "F_Response"
F_ResponseClock = core.Clock()
TextFrame = visual.Rect(
    win=win, name='TextFrame',units='height', 
    width=(0.5, 0.15)[0], height=(0.5, 0.15)[1],
    ori=0, pos=(0, 0),
    lineWidth=15, lineColor=[-1,-1,-1], lineColorSpace='rgb',
    fillColor=[0,0,0], fillColorSpace='rgb',
    opacity=1, depth=0.0, interpolate=True)
instr = visual.TextStim(win=win, name='instr',
    text='Type the answer in the frame below, \nand press return',
    font='Arial',
    units='norm', pos=(0, 0.5), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);
text = visual.TextStim(win=win, name='text',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "G_End"
G_EndClock = core.Clock()
text_2 = visual.TextStim(win=win, name='text_2',
    text='Thank you for participanting in the experiment!',
    font='Arial',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "A_Start"-------
continueRoutine = True
# update component parameters for each repeat
key_resp.keys = []
key_resp.rt = []
_key_resp_allKeys = []
# keep track of which components have finished
A_StartComponents = [instText, key_resp]
for thisComponent in A_StartComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
A_StartClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "A_Start"-------
while continueRoutine:
    # get current time
    t = A_StartClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=A_StartClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *instText* updates
    if instText.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instText.frameNStart = frameN  # exact frame index
        instText.tStart = t  # local t and not account for scr refresh
        instText.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instText, 'tStartRefresh')  # time at next scr refresh
        instText.setAutoDraw(True)
    
    # *key_resp* updates
    waitOnFlip = False
    if key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        key_resp.frameNStart = frameN  # exact frame index
        key_resp.tStart = t  # local t and not account for scr refresh
        key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_resp, 'tStartRefresh')  # time at next scr refresh
        key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_resp.status == STARTED and not waitOnFlip:
        theseKeys = key_resp.getKeys(keyList=['space'], waitRelease=False)
        _key_resp_allKeys.extend(theseKeys)
        if len(_key_resp_allKeys):
            key_resp.keys = _key_resp_allKeys[-1].name  # just the last key pressed
            key_resp.rt = _key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in A_StartComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "A_Start"-------
for thisComponent in A_StartComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('instText.started', instText.tStartRefresh)
thisExp.addData('instText.stopped', instText.tStopRefresh)
# check responses
if key_resp.keys in ['', [], None]:  # No response was made
    key_resp.keys = None
thisExp.addData('key_resp.keys',key_resp.keys)
if key_resp.keys != None:  # we had a response
    thisExp.addData('key_resp.rt', key_resp.rt)
thisExp.addData('key_resp.started', key_resp.tStartRefresh)
thisExp.addData('key_resp.stopped', key_resp.tStopRefresh)
thisExp.nextEntry()
# the Routine "A_Start" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "B_Consent1"-------
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the Mouse1
Mouse1.clicked_name = []
gotValidClick = False  # until a click is received
# keep track of which components have finished
B_Consent1Components = [ConsentForm1, Button1, Mouse1]
for thisComponent in B_Consent1Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
B_Consent1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "B_Consent1"-------
while continueRoutine:
    # get current time
    t = B_Consent1Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=B_Consent1Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *ConsentForm1* updates
    if ConsentForm1.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        ConsentForm1.frameNStart = frameN  # exact frame index
        ConsentForm1.tStart = t  # local t and not account for scr refresh
        ConsentForm1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(ConsentForm1, 'tStartRefresh')  # time at next scr refresh
        ConsentForm1.setAutoDraw(True)
    
    # *Button1* updates
    if Button1.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Button1.frameNStart = frameN  # exact frame index
        Button1.tStart = t  # local t and not account for scr refresh
        Button1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Button1, 'tStartRefresh')  # time at next scr refresh
        Button1.setAutoDraw(True)
    # *Mouse1* updates
    if Mouse1.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mouse1.frameNStart = frameN  # exact frame index
        Mouse1.tStart = t  # local t and not account for scr refresh
        Mouse1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mouse1, 'tStartRefresh')  # time at next scr refresh
        Mouse1.status = STARTED
        Mouse1.mouseClock.reset()
        prevButtonState = Mouse1.getPressed()  # if button is down already this ISN'T a new click
    if Mouse1.status == STARTED:  # only update if started and not finished!
        buttons = Mouse1.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [Button1]:
                    if obj.contains(Mouse1):
                        gotValidClick = True
                        Mouse1.clicked_name.append(obj.name)
                if gotValidClick:  # abort routine on response
                    continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in B_Consent1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "B_Consent1"-------
for thisComponent in B_Consent1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('ConsentForm1.started', ConsentForm1.tStartRefresh)
thisExp.addData('ConsentForm1.stopped', ConsentForm1.tStopRefresh)
thisExp.addData('Button1.started', Button1.tStartRefresh)
thisExp.addData('Button1.stopped', Button1.tStopRefresh)
# store data for thisExp (ExperimentHandler)
x, y = Mouse1.getPos()
buttons = Mouse1.getPressed()
if sum(buttons):
    # check if the mouse was inside our 'clickable' objects
    gotValidClick = False
    for obj in [Button1]:
        if obj.contains(Mouse1):
            gotValidClick = True
            Mouse1.clicked_name.append(obj.name)
thisExp.addData('Mouse1.x', x)
thisExp.addData('Mouse1.y', y)
thisExp.addData('Mouse1.leftButton', buttons[0])
thisExp.addData('Mouse1.midButton', buttons[1])
thisExp.addData('Mouse1.rightButton', buttons[2])
if len(Mouse1.clicked_name):
    thisExp.addData('Mouse1.clicked_name', Mouse1.clicked_name[0])
thisExp.addData('Mouse1.started', Mouse1.tStart)
thisExp.addData('Mouse1.stopped', Mouse1.tStop)
thisExp.nextEntry()
# the Routine "B_Consent1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "C_Consent2"-------
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the Mouse2
Mouse2.clicked_name = []
gotValidClick = False  # until a click is received
# keep track of which components have finished
C_Consent2Components = [ConsentForm2, Button2, Mouse2]
for thisComponent in C_Consent2Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
C_Consent2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "C_Consent2"-------
while continueRoutine:
    # get current time
    t = C_Consent2Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=C_Consent2Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *ConsentForm2* updates
    if ConsentForm2.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        ConsentForm2.frameNStart = frameN  # exact frame index
        ConsentForm2.tStart = t  # local t and not account for scr refresh
        ConsentForm2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(ConsentForm2, 'tStartRefresh')  # time at next scr refresh
        ConsentForm2.setAutoDraw(True)
    
    # *Button2* updates
    if Button2.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Button2.frameNStart = frameN  # exact frame index
        Button2.tStart = t  # local t and not account for scr refresh
        Button2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Button2, 'tStartRefresh')  # time at next scr refresh
        Button2.setAutoDraw(True)
    # *Mouse2* updates
    if Mouse2.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mouse2.frameNStart = frameN  # exact frame index
        Mouse2.tStart = t  # local t and not account for scr refresh
        Mouse2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mouse2, 'tStartRefresh')  # time at next scr refresh
        Mouse2.status = STARTED
        Mouse2.mouseClock.reset()
        prevButtonState = Mouse2.getPressed()  # if button is down already this ISN'T a new click
    if Mouse2.status == STARTED:  # only update if started and not finished!
        buttons = Mouse2.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [Button2]:
                    if obj.contains(Mouse2):
                        gotValidClick = True
                        Mouse2.clicked_name.append(obj.name)
                if gotValidClick:  # abort routine on response
                    continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in C_Consent2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "C_Consent2"-------
for thisComponent in C_Consent2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('ConsentForm2.started', ConsentForm2.tStartRefresh)
thisExp.addData('ConsentForm2.stopped', ConsentForm2.tStopRefresh)
thisExp.addData('Button2.started', Button2.tStartRefresh)
thisExp.addData('Button2.stopped', Button2.tStopRefresh)
# store data for thisExp (ExperimentHandler)
thisExp.addData('Mouse2.started', Mouse2.tStart)
thisExp.addData('Mouse2.stopped', Mouse2.tStop)
thisExp.nextEntry()
# the Routine "C_Consent2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "D_Consent3"-------
continueRoutine = True
# update component parameters for each repeat
# setup some python lists for storing info about the Mouse3
Mouse3.clicked_name = []
gotValidClick = False  # until a click is received
# keep track of which components have finished
D_Consent3Components = [ConsentForm3, Button_Agree, Button_Disagree, Mouse3]
for thisComponent in D_Consent3Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
D_Consent3Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "D_Consent3"-------
while continueRoutine:
    # get current time
    t = D_Consent3Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=D_Consent3Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *ConsentForm3* updates
    if ConsentForm3.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        ConsentForm3.frameNStart = frameN  # exact frame index
        ConsentForm3.tStart = t  # local t and not account for scr refresh
        ConsentForm3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(ConsentForm3, 'tStartRefresh')  # time at next scr refresh
        ConsentForm3.setAutoDraw(True)
    
    # *Button_Agree* updates
    if Button_Agree.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Button_Agree.frameNStart = frameN  # exact frame index
        Button_Agree.tStart = t  # local t and not account for scr refresh
        Button_Agree.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Button_Agree, 'tStartRefresh')  # time at next scr refresh
        Button_Agree.setAutoDraw(True)
    
    # *Button_Disagree* updates
    if Button_Disagree.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Button_Disagree.frameNStart = frameN  # exact frame index
        Button_Disagree.tStart = t  # local t and not account for scr refresh
        Button_Disagree.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Button_Disagree, 'tStartRefresh')  # time at next scr refresh
        Button_Disagree.setAutoDraw(True)
    # *Mouse3* updates
    if Mouse3.status == NOT_STARTED and frameN >= 0.0:
        # keep track of start time/frame for later
        Mouse3.frameNStart = frameN  # exact frame index
        Mouse3.tStart = t  # local t and not account for scr refresh
        Mouse3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Mouse3, 'tStartRefresh')  # time at next scr refresh
        Mouse3.status = STARTED
        Mouse3.mouseClock.reset()
        prevButtonState = Mouse3.getPressed()  # if button is down already this ISN'T a new click
    if Mouse3.status == STARTED:  # only update if started and not finished!
        buttons = Mouse3.getPressed()
        if buttons != prevButtonState:  # button state changed?
            prevButtonState = buttons
            if sum(buttons) > 0:  # state changed to a new click
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [Button_Agree]:
                    if obj.contains(Mouse3):
                        gotValidClick = True
                        Mouse3.clicked_name.append(obj.name)
                if gotValidClick:  # abort routine on response
                    continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in D_Consent3Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "D_Consent3"-------
for thisComponent in D_Consent3Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('ConsentForm3.started', ConsentForm3.tStartRefresh)
thisExp.addData('ConsentForm3.stopped', ConsentForm3.tStopRefresh)
thisExp.addData('Button_Agree.started', Button_Agree.tStartRefresh)
thisExp.addData('Button_Agree.stopped', Button_Agree.tStopRefresh)
thisExp.addData('Button_Disagree.started', Button_Disagree.tStartRefresh)
thisExp.addData('Button_Disagree.stopped', Button_Disagree.tStopRefresh)
# store data for thisExp (ExperimentHandler)
thisExp.addData('Mouse3.started', Mouse3.tStart)
thisExp.addData('Mouse3.stopped', Mouse3.tStop)
thisExp.nextEntry()
# the Routine "D_Consent3" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "E_Video"-------
continueRoutine = True
# update component parameters for each repeat
# keep track of which components have finished
E_VideoComponents = [movie]
for thisComponent in E_VideoComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
E_VideoClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "E_Video"-------
while continueRoutine:
    # get current time
    t = E_VideoClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=E_VideoClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *movie* updates
    if movie.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        movie.frameNStart = frameN  # exact frame index
        movie.tStart = t  # local t and not account for scr refresh
        movie.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(movie, 'tStartRefresh')  # time at next scr refresh
        movie.setAutoDraw(True)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in E_VideoComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "E_Video"-------
for thisComponent in E_VideoComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('movie.started', movie.tStartRefresh)
thisExp.addData('movie.stopped', movie.tStopRefresh)
# the Routine "E_Video" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
trials = data.TrialHandler(nReps=1, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='trials')
thisExp.addLoop(trials)  # add the loop to the experiment
thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
if thisTrial != None:
    for paramName in thisTrial:
        exec('{} = thisTrial[paramName]'.format(paramName))

for thisTrial in trials:
    currentLoop = trials
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial:
            exec('{} = thisTrial[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "F_Response"-------
    continueRoutine = True
    # update component parameters for each repeat
    modify = False
    text.text = ''
    event.clearEvents('keyboard')
    # keep track of which components have finished
    F_ResponseComponents = [TextFrame, instr, text]
    for thisComponent in F_ResponseComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    F_ResponseClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "F_Response"-------
    while continueRoutine:
        # get current time
        t = F_ResponseClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=F_ResponseClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *TextFrame* updates
        if TextFrame.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            TextFrame.frameNStart = frameN  # exact frame index
            TextFrame.tStart = t  # local t and not account for scr refresh
            TextFrame.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(TextFrame, 'tStartRefresh')  # time at next scr refresh
            TextFrame.setAutoDraw(True)
        
        # *instr* updates
        if instr.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            instr.frameNStart = frameN  # exact frame index
            instr.tStart = t  # local t and not account for scr refresh
            instr.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(instr, 'tStartRefresh')  # time at next scr refresh
            instr.setAutoDraw(True)
        
        # *text* updates
        if text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text.frameNStart = frameN  # exact frame index
            text.tStart = t  # local t and not account for scr refresh
            text.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text, 'tStartRefresh')  # time at next scr refresh
            text.setAutoDraw(True)
        keys = event.getKeys()
        if len(keys):
            if 'space' in keys:
                text.text = text.text + ' '
            elif 'backspace' in keys:
                text.text = text.text[:-1]
            elif 'lshift' in keys or 'rshift' in keys:
                modify = True
            elif 'return' in keys:
                continueRoutine = False
            else:
                if modify:
                    text.text = text.text + keys[0].upper()
                    modify = False
                else:
                    text.text = text.text + keys[0]
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in F_ResponseComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "F_Response"-------
    for thisComponent in F_ResponseComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    trials.addData('TextFrame.started', TextFrame.tStartRefresh)
    trials.addData('TextFrame.stopped', TextFrame.tStopRefresh)
    trials.addData('instr.started', instr.tStartRefresh)
    trials.addData('instr.stopped', instr.tStopRefresh)
    trials.addData('text.started', text.tStartRefresh)
    trials.addData('text.stopped', text.tStopRefresh)
    thisExp.addData("typedWord", text.text)
    # the Routine "F_Response" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 1 repeats of 'trials'


# ------Prepare to start Routine "G_End"-------
continueRoutine = True
routineTimer.add(5.000000)
# update component parameters for each repeat
# keep track of which components have finished
G_EndComponents = [text_2]
for thisComponent in G_EndComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
G_EndClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "G_End"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = G_EndClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=G_EndClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_2* updates
    if text_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_2.frameNStart = frameN  # exact frame index
        text_2.tStart = t  # local t and not account for scr refresh
        text_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_2, 'tStartRefresh')  # time at next scr refresh
        text_2.setAutoDraw(True)
    if text_2.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > text_2.tStartRefresh + 5-frameTolerance:
            # keep track of stop time/frame for later
            text_2.tStop = t  # not accounting for scr refresh
            text_2.frameNStop = frameN  # exact frame index
            win.timeOnFlip(text_2, 'tStopRefresh')  # time at next scr refresh
            text_2.setAutoDraw(False)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in G_EndComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "G_End"-------
for thisComponent in G_EndComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('text_2.started', text_2.tStartRefresh)
thisExp.addData('text_2.stopped', text_2.tStopRefresh)

# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
